﻿# -*- coding: UTF-8 -*-
# Chinese braille reader for NVDA by Coscell Kao <coscell@gmail.com>
import os
import globalPluginHandler
import globalVars
import speechDictHandler
import ui

dic = os.path.join(os.path.dirname(os.path.abspath(__file__)), "brl.dic")
sD = speechDictHandler.SpeechDict()
brl = False

def brlon():
  global brl
  speechDictHandler.dictionaries["temp"].extend(sD)
  brl = True

def brloff():
  global brl
  for entry in sD:
    if entry in speechDictHandler.dictionaries["temp"]:
      speechDictHandler.dictionaries["temp"].remove(entry)
  brl = False

class GlobalPlugin(globalPluginHandler.GlobalPlugin):

  def __init__(self):
    super(globalPluginHandler.GlobalPlugin, self).__init__()
    global sD, dic
    sD.load(dic)

  def terminate(self):
    brloff()
    global sD 
    sD = None

  def script_toggle(self, gesture):
    if not globalVars.speechDictionaryProcessing:
      return
    if brl:
      brloff()
      ui.message(_(u"報點關"))
    else:
      brlon()
      ui.message(_(u"報點開"))
  script_toggle.__doc__ = _(u"報讀點字功能開關")

  __gestures = {
    "kb:NVDA+.":"toggle"
  }
